Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Model.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Model.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Model.cs	(revision 2223)
@@ -0,0 +1,141 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "Model")]
+  public class Model : IModel {
+    public Model() {
+      targetVariable = default(EntityRef<Variable>);
+      algorithm = default(EntityRef<Algorithm>);
+    }
+
+    public Model(Variable targetVariable, Algorithm algorithm)
+      : this() {
+      this.targetVariableId = targetVariable.Id;
+      this.algorithmId = algorithm.Id;
+    }
+
+    private int id;
+    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
+    public int Id {
+      get { return this.id; }
+      private set { this.id = value; }
+    }
+
+    private int algorithmId;
+    [Column(Storage = "algorithmId", CanBeNull = false)]
+    public int AlgorithmId {
+      get { return this.algorithmId; }
+      private set {
+        if (algorithmId != value) {
+          if (algorithm.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          algorithmId = value;
+        }
+      }
+    }
+
+    private EntityRef<Algorithm> algorithm;
+    [Association(Storage = "algorithm", ThisKey = "AlgorithmId", OtherKey = "Id", IsForeignKey = true)]
+    public Algorithm Algorithm {
+      get { return this.algorithm.Entity; }
+      //private set {
+      //  Algorithm previousValue = algorithm.Entity;
+      //  if (previousValue != value || (!algorithm.HasLoadedOrAssignedValue)) {
+      //    if (previousValue != null) {
+      //      algorithm.Entity = null;
+      //    }
+      //    algorithm.Entity = value;
+      //    if (value != null) {
+      //      algorithmId = value.Id;
+      //    }
+      //  }
+      //}
+    }
+
+    IAlgorithm IModel.Algorithm {
+      get { return this.Algorithm; }
+    }
+
+    private int targetVariableId;
+    [Column(Storage = "targetVariableId", CanBeNull = false)]
+    public int TargetVariableId {
+      get { return this.targetVariableId; }
+      private set {
+        if (targetVariableId != value) {
+          if (targetVariable.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          targetVariableId = value;
+        }
+      }
+    }
+
+    private EntityRef<Variable> targetVariable;
+    [Association(Storage = "targetVariable", ThisKey = "TargetVariableId", OtherKey = "Id", IsForeignKey = true)]
+    public Variable TargetVariable {
+      get { return this.targetVariable.Entity; }
+      //private set {
+      //  Variable previousValue = targetVariable.Entity;
+      //  if (previousValue != value || (!targetVariable.HasLoadedOrAssignedValue)) {
+      //    if (previousValue != null) {
+      //      targetVariable.Entity = null;
+      //    }
+      //    targetVariable.Entity = value;
+      //    if (value != null) {
+      //      targetVariableId = value.Id;
+      //    }
+      //  }
+      //}
+    }
+
+    IVariable IModel.TargetVariable {
+      get { return this.TargetVariable; }
+    }
+
+    private int trainingSamplesStart;
+    [Column(Storage = "trainingSamplesStart", CanBeNull = false)]
+    public int TrainingSamplesStart {
+      get { return this.trainingSamplesStart; }
+      set { this.trainingSamplesStart = value; }
+    }
+
+    private int trainingSamplesEnd;
+    [Column(Storage = "trainingSamplesEnd", CanBeNull = false)]
+    public int TrainingSamplesEnd {
+      get { return this.trainingSamplesEnd; }
+      set { this.trainingSamplesEnd = value; }
+    }
+
+    private int validationSamplesStart;
+    [Column(Storage = "validationSamplesStart", CanBeNull = false)]
+    public int ValidationSamplesStart {
+      get { return this.validationSamplesStart; }
+      set { this.validationSamplesStart = value; }
+    }
+
+    private int validationSamplesEnd;
+    [Column(Storage = "validationSamplesEnd", CanBeNull = false)]
+    public int ValidationSamplesEnd {
+      get { return this.validationSamplesEnd; }
+      set { this.validationSamplesEnd = value; }
+    }
+
+    private int testSamplesStart;
+    [Column(Storage = "testSamplesStart", CanBeNull = false)]
+    public int TestSamplesStart {
+      get { return this.testSamplesStart; }
+      set { this.testSamplesStart = value; }
+    }
+
+    private int testSamplesEnd;
+    [Column(Storage = "testSamplesEnd", CanBeNull = false)]
+    public int TestSamplesEnd {
+      get { return this.testSamplesEnd; }
+      set { this.testSamplesEnd = value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/ModelData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/ModelData.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/ModelData.cs	(revision 2223)
@@ -0,0 +1,48 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "ModelData")]
+  public class ModelData {
+
+    public ModelData() {
+      this.model = default(EntityRef<Model>);
+    }
+
+    public ModelData(Model model, byte[] data)
+      : base() {
+      this.modelId = model.Id;
+      this.data = data;
+    }
+
+
+    private int modelId;
+    [Column(Storage = "modelId", IsPrimaryKey = true)]
+    public int ModelId {
+      get { return this.modelId; }
+      private set {
+        if (modelId != value) {
+          if (model.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          modelId = value;
+        }
+      }
+    }
+
+    private EntityRef<Model> model;
+    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
+    public Model Model {
+      get { return model.Entity; }
+    }
+
+    private byte[] data;
+    [Column(Storage = "data", DbType = "image", CanBeNull = false)]
+    public byte[] Data {
+      get { return this.data; }
+      private set { this.data = value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/ModelResult.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/ModelResult.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/ModelResult.cs	(revision 2223)
@@ -0,0 +1,100 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "ModelResult")]
+  public class ModelResult : IModelResult {
+    public ModelResult() {
+      this.model = default(EntityRef<Model>);
+      this.result = default(EntityRef<Result>);
+    }
+
+    public ModelResult(Model model, Result result, double value)
+      : this() {
+      this.modelId = model.Id;
+      this.resultId = result.Id;
+      this.value = value;
+    }
+
+    private double value;
+    [Column(Storage = "value", CanBeNull = false)]
+    public double Value {
+      get { return this.value; }
+      set { this.value = value; }
+    }
+
+    private int modelId;
+    [Column(Storage = "modelId",IsPrimaryKey = true, CanBeNull = false)]
+    public int ModelId {
+      get { return this.modelId; }
+      private set {
+        if (modelId != value) {
+          if (model.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+        }
+        modelId = value;
+      }
+    }
+
+    private EntityRef<Model> model;
+    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
+    public Model Model {
+      get { return this.model.Entity; }
+      //set {
+      //  Model previousValue = model.Entity;
+      //  if (previousValue != value || (!model.HasLoadedOrAssignedValue)) {
+      //    if (previousValue != null) {
+      //      model.Entity = null;
+      //    }
+      //    model.Entity = value;
+      //    if (value != null) {
+      //      modelId = value.Id;
+      //    } 
+      //  }
+      //}
+    }
+
+    IModel IModelResult.Model {
+      get { return this.Model; }
+    }
+
+    private int resultId;
+    [Column(Storage = "resultId",IsPrimaryKey = true, CanBeNull = false)]
+    public int ResultId {
+      get { return this.resultId; }
+      private set {
+        if (resultId != value) {
+          if (result.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+        }
+        modelId = value;
+      }
+    }
+
+    private EntityRef<Result> result;
+    [Association(Storage = "result", ThisKey = "ResultId", OtherKey = "Id", IsForeignKey = true)]
+    public Result Result {
+      get { return this.result.Entity; }
+      //set {
+      //  Result previousValue = result.Entity;
+      //  if (previousValue != value || (!model.HasLoadedOrAssignedValue)) {
+      //    if (previousValue != null) {
+      //      result.Entity = null;
+      //    }
+      //    result.Entity = value;
+      //    if (value != null) {
+      //      resultId = value.Id;
+      //    }
+      //  }
+      //}
+    }
+
+    IResult IModelResult.Result {
+      get { return this.Result; }
+    }
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Problem.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Problem.cs	(revision 2223)
@@ -0,0 +1,40 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+using HeuristicLab.DataAnalysis;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "Problem")]
+  public class Problem : IProblem {
+    public Problem() {
+    }
+
+    public Problem(Dataset dataset)
+      : this() {
+      this.Dataset = dataset;
+    }
+
+    private int id;
+    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
+    public int Id {
+      get { return this.id; }
+      private set { this.id = value; }
+    }
+
+    private byte[] data;
+    [Column(Storage = "data", DbType = "image", CanBeNull = false)]
+    public byte[] Data {
+      get { return this.data; }
+      private set { this.data = value; }
+    }
+
+    public Dataset Dataset {
+      get { return (Dataset)PersistenceManager.RestoreFromGZip(this.Data); }
+      set { this.Data = PersistenceManager.SaveToGZip(value); }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Result.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Result.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Result.cs	(revision 2223)
@@ -0,0 +1,33 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "Result")]
+  public class Result : IResult {
+    public Result() {
+    }
+
+    public Result(string name)
+      : this() {
+      this.name = name;
+    }
+
+    private int id;
+    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
+    public int Id {
+      get { return this.id; }
+      private set { this.id = value; }
+    }
+
+    private string name;
+    [Column(Storage = "name", CanBeNull = false)]
+    public string Name {
+      get { return this.name; }
+      private set { this.name = value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Variable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Variable.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Variable.cs	(revision 2223)
@@ -0,0 +1,33 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "Variable")]
+  public class Variable : IVariable{
+    public Variable() {
+    }
+
+    public Variable(string name)
+      : this() {
+      this.name = name;
+    }
+
+    private int id;
+    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
+    public int Id {
+      get { return this.id; }
+      private set { this.id = value; }
+    }
+
+    private string name;
+    [Column(Storage = "name", CanBeNull = false)]
+    public string Name {
+      get { return this.name; }
+      private set { this.name = value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DatabaseService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DatabaseService.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DatabaseService.cs	(revision 2223)
@@ -0,0 +1,250 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Reflection;
+
+using HeuristicLab.Core;
+using HeuristicLab.DataAnalysis;
+using HeuristicLab.Data;
+using System.Data.Linq;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  public class DatabaseService : IModelingDatabase {
+
+    private readonly string connection;
+    public DatabaseService(string connection) {
+      this.connection = connection;
+      Connect();
+      if (!ctx.DatabaseExists())
+        ctx.CreateDatabase();
+    }
+
+    private void EmptyDatabase() {
+      ctx.DeleteDatabase();
+      ctx.CreateDatabase();
+    }
+
+    private ModelingDataContext ctx;
+    public void Connect() {
+      if (ctx != null)
+        return;
+
+      ctx = new ModelingDataContext(connection);
+      DataLoadOptions dlo = new DataLoadOptions();
+      dlo.LoadWith<ModelResult>(mr => mr.Result);
+      dlo.LoadWith<InputVariableResult>(ir => ir.Variable);
+      dlo.LoadWith<InputVariableResult>(ir => ir.Result);
+      dlo.LoadWith<Model>(m => m.TargetVariable);
+      ctx.LoadOptions = dlo;
+    }
+
+    public void Disconnect() {
+      if (ctx == null)
+        return;
+      ctx.Dispose();
+      ctx = null;
+    }
+
+    public void Persist(HeuristicLab.Modeling.IAlgorithm algorithm) {
+      int trainingSamplesStart = ((IntData)algorithm.Engine.GlobalScope.GetVariableValue("TrainingSamplesStart", false)).Data;
+      int trainingSamplesEnd = ((IntData)algorithm.Engine.GlobalScope.GetVariableValue("TrainingSamplesEnd", false)).Data;
+      int validationSamplesStart = ((IntData)algorithm.Engine.GlobalScope.GetVariableValue("ValidationSamplesStart", false)).Data;
+      int validationSamplesEnd = ((IntData)algorithm.Engine.GlobalScope.GetVariableValue("ValidationSamplesEnd", false)).Data;
+      int testSamplesStart = ((IntData)algorithm.Engine.GlobalScope.GetVariableValue("TestSamplesStart", false)).Data;
+      int testSamplesEnd = ((IntData)algorithm.Engine.GlobalScope.GetVariableValue("TestSamplesEnd", false)).Data;
+
+      GetOrCreateProblem(algorithm.Dataset);
+      Dictionary<string, Variable> variables = GetAllVariables();
+      Algorithm algo = GetOrCreateAlgorithm(algorithm.Name, algorithm.Description);
+      Variable target = variables[algorithm.Model.TargetVariable];
+      Model model;
+
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        model = new Model(target, algo);
+        model.TrainingSamplesStart = trainingSamplesStart;
+        model.TrainingSamplesEnd = trainingSamplesEnd;
+        model.ValidationSamplesStart = validationSamplesStart;
+        model.ValidationSamplesEnd = validationSamplesEnd;
+        model.TestSamplesStart = testSamplesStart;
+        model.TestSamplesEnd = testSamplesEnd;
+
+        ctx.Models.InsertOnSubmit(model);
+
+        ctx.SubmitChanges();
+      }
+
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        ctx.ModelData.InsertOnSubmit(new ModelData(model, PersistenceManager.SaveToGZip(algorithm.Model.Data)));
+      }
+
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        foreach (string inputVariable in algorithm.Model.InputVariables) {
+          ctx.InputVariables.InsertOnSubmit(new InputVariable(model, variables[inputVariable]));
+        }
+        ctx.SubmitChanges();
+      }
+
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        //get all double properties to save as modelResult
+        IEnumerable<PropertyInfo> modelResultInfos = algorithm.Model.GetType().GetProperties().Where(
+          info => info.PropertyType == typeof(double));
+        foreach (PropertyInfo modelResultInfo in modelResultInfos) {
+          Result result = GetOrCreateResult(modelResultInfo.Name);
+          double value = (double)modelResultInfo.GetValue(algorithm.Model, null);
+          ctx.ModelResults.InsertOnSubmit(new ModelResult(model, result, value));
+        }
+        ctx.SubmitChanges();
+      }
+
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        IEnumerable<MethodInfo> inputVariableResultInfos = algorithm.Model.GetType().GetMethods().Where(
+          info => info.GetParameters().Count() == 1 &&
+             info.GetParameters()[0].ParameterType == typeof(string) &&
+             info.GetParameters()[0].Name == "variableName" &&
+             info.ReturnParameter.ParameterType == typeof(double) &&
+             info.Name.StartsWith("Get"));
+        foreach (MethodInfo inputVariableResultInfo in inputVariableResultInfos) {
+          Result result = GetOrCreateResult(inputVariableResultInfo.Name.Substring(3));
+          foreach (InputVariable variable in ctx.InputVariables.Where(iv => iv.Model == model)) {
+            double value = (double)inputVariableResultInfo.Invoke(algorithm.Model, new object[] { variable.Variable.Name });
+            ctx.InputVariableResults.InsertOnSubmit(new InputVariableResult(variable, result, value));
+          }
+        }
+        ctx.SubmitChanges();
+      }
+
+    }
+
+    #region Problem
+
+    public Dataset GetDataset() {
+      if (ctx.Problems.Count() != 1)
+        throw new InvalidOperationException("Could not get dataset. No or more than one problems are persisted in the database.");
+
+      Problem problem = ctx.Problems.Single();
+      return problem.Dataset;
+
+    }
+
+    public Problem GetOrCreateProblem(Dataset dataset) {
+      Problem problem;
+      if (ctx.Problems.Count() == 0)
+        problem = PersistProblem(dataset);
+      else
+        problem = ctx.Problems.Single();
+      if (problem.Dataset.ToString() != dataset.ToString())
+        throw new InvalidOperationException("Could not persist dataset. The database already contains a different dataset.");
+      return problem;
+    }
+
+    private Problem PersistProblem(Dataset dataset) {
+      Problem problem;
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        if (ctx.Problems.Count() != 0)
+          throw new InvalidOperationException("Could not persist dataset. A dataset is already saved in the database.");
+        problem = new Problem(dataset);
+        ctx.Problems.InsertOnSubmit(problem);
+        foreach (string variable in dataset.VariableNames) {
+          ctx.Variables.InsertOnSubmit(new Variable(variable));
+        }
+        ctx.SubmitChanges();
+      }
+      return problem;
+    }
+
+    #endregion
+
+    #region Algorithm
+    public Algorithm GetOrCreateAlgorithm(string name, string description) {
+      Algorithm algorithm;
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        var algorithms = from algo in ctx.Algorithms
+                         where algo.Name == name && algo.Description == description
+                         select algo;
+        if (algorithms.Count() == 0) {
+          algorithm = new Algorithm(name, description);
+          ctx.Algorithms.InsertOnSubmit(algorithm);
+          ctx.SubmitChanges();
+        } else if (algorithms.Count() == 1)
+          algorithm = algorithms.Single();
+        else
+          throw new ArgumentException("Could not get Algorithm. More than one algorithm with the name " + name + " are saved in database.");
+      }
+      return algorithm;
+    }
+    #endregion
+
+    #region Variables
+    public Dictionary<string, Variable> GetAllVariables() {
+      Dictionary<string, Variable> dict = new Dictionary<string, Variable>();
+      dict = ctx.Variables.ToDictionary<Variable, string>(delegate(Variable v) { return v.Name; });
+      return dict;
+    }
+    #endregion
+
+    #region Result
+    public Result GetOrCreateResult(string name) {
+      Result result;
+      using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
+        var results = from r in ctx.Results
+                      where r.Name == name
+                      select r;
+        if (results.Count() == 0) {
+          result = new Result(name);
+          ctx.Results.InsertOnSubmit(result);
+          ctx.SubmitChanges();
+        } else if (results.Count() == 1)
+          result = results.Single();
+        else
+          throw new ArgumentException("Could not get result. More than one result with the name " + name + " are saved in database.");
+      }
+      return result;
+    }
+
+    public IEnumerable<IResult> GetAllResults() {
+      return ctx.Results.ToList().Cast<IResult>();
+    }
+
+    public IEnumerable<IResult> GetAllResultsForInputVariables() {
+      return (from ir in ctx.InputVariableResults select ir.Result).Distinct().ToList().Cast<IResult>();
+    }
+
+    #endregion
+
+    #region ModelResult
+    public IEnumerable<IModelResult> GetModelResults(IModel model) {
+      var results = from result in ctx.ModelResults
+                    where result.Model == model
+                    select result;
+      return results.ToList().Cast<IModelResult>();
+    }
+    #endregion
+
+    #region InputVariableResults
+    public IEnumerable<IInputVariableResult> GetInputVariableResults(IModel model) {
+      var inputResults = from ir in ctx.InputVariableResults
+                         where ir.Model == model
+                         select ir;
+      return inputResults.ToList().Cast<IInputVariableResult>();
+    }
+
+    #endregion
+
+    #region Model
+    public IEnumerable<IModel> GetAllModels() {
+      return ctx.Models.ToList().Cast<IModel>();
+    }
+
+    public byte[] GetModelData(IModel model) {
+      var data = (from md in ctx.ModelData
+                  where md.Model == model
+                  select md);
+      if (data.Count() == 0)
+        return null;
+      return data.Single().Data;
+    }
+    #endregion
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/HeuristicLab.Modeling.Database.SQLServerCompact-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/HeuristicLab.Modeling.Database.SQLServerCompact-3.2.csproj	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/HeuristicLab.Modeling.Database.SQLServerCompact-3.2.csproj	(revision 2223)
@@ -0,0 +1,149 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{EC1AA756-D612-4FA6-AA52-25CF4F8E3836}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Modeling.Database.SQLServerCompact</RootNamespace>
+    <AssemblyName>HeuristicLab.Modeling.Database.SQLServerCompact-3.2</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Xml.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.2\HeuristicLab.Core-3.2.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.DataAnalysis\3.2\HeuristicLab.DataAnalysis-3.2.csproj">
+      <Project>{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}</Project>
+      <Name>HeuristicLab.DataAnalysis-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.2\HeuristicLab.Data-3.2.csproj">
+      <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
+      <Name>HeuristicLab.Data-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Modeling.Database\3.2\HeuristicLab.Modeling.Database-3.2.csproj">
+      <Project>{E84E5717-79F8-498F-A5E0-A055C4EC086B}</Project>
+      <Name>HeuristicLab.Modeling.Database-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Modeling\3.2\HeuristicLab.Modeling-3.2.csproj">
+      <Project>{80F7FADA-549D-4151-8856-79B620A50DBA}</Project>
+      <Name>HeuristicLab.Modeling-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.SQLServerCompact\3.2\HeuristicLab.SQLServerCompact-3.2.csproj">
+      <Project>{31DD6385-7276-49ED-9533-823D4CDF3D2A}</Project>
+      <Name>HeuristicLab.SQLServerCompact-3.2</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="DatabaseService.cs" />
+    <Compile Include="DataObjects\Algorithm.cs" />
+    <Compile Include="DataObjects\InputVariable.cs" />
+    <Compile Include="DataObjects\InputVariableResult.cs" />
+    <Compile Include="DataObjects\Model.cs" />
+    <Compile Include="DataObjects\ModelData.cs" />
+    <Compile Include="HeuristicLabModelingDatabaseSQLServerCompactPlugin.cs" />
+    <Compile Include="ModelingDataContext.cs" />
+    <Compile Include="DataObjects\ModelResult.cs" />
+    <Compile Include="DataObjects\Problem.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="DataObjects\Result.cs" />
+    <Compile Include="DataObjects\Variable.cs" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+</Project>
